-- (pretty) Fast flat-triangle filler 
-- By Mic, 2000
--
-- Only works in 320*200*8bit mode at the moment.
--


include asm.e


--STRUCT tri_data=
-- {
--  DWORD *vp1,*vp2,*vp3	//vertex-pointers
--  DWORD x[3]
--  DWORD y[3]
--  DWORD color
--  DWORD delta_x[3]
--  DWORD delta_y[3]
--  DWORD d[3]
--  DWORD *horizline_proc 
-- }
global constant tri_data=allocate(120)

constant tMaxH=allocate(20),
	 tMaxW=tMaxH+4,
	 tScreenW=tMaxH+8

global constant hzline_proc=allocate(4)
global constant hzline_data=allocate(40)



global constant drawsection8=get_asm(
"mov eax,[start_y] "&
"cmp eax,[maxH] "&
"jng ds8_@y1_ok "&
"ret "&
"ds8_@y1_ok: "&
"mov ecx,[end_y] "&
"cmp ecx,0 "&
"jge ds8_@y2_ok "&
"ret "&
"ds8_@y2_ok: "&
"cmp eax,0 "&
"jge ds8_@y1_ok_2 "&
"mov eax,0 "&
"ds8_@y1_ok_2: "&
"cmp ecx,[maxH] "&
"jng ds8_@y2_ok_2 "&
"mov ecx,[maxH] "&
"ds8_@y2_ok_2: "&
"sub ecx,eax "&
"inc ecx "&
"cmp ecx,0 "&
"jg ds8_@height_ok "&
"ret "&
"ds8_@height_ok: "&
"imul dword ptr [screenW] "&
"add edi,eax "&					-- edi = dest+(y*screenW)
"mov ebp,[x1] "&
"mov ebx,[x2] "&
"ds8_@yloop: "&
"push edi "&
"push ecx "&
--"mov edx,ecx "&
"mov [x1],ebp "&
--"mov [x2],ebx "&
"mov edx,ebx "&
"sar ebp,9 "&
"sar ebx,9 "&
"cmp ebp,ebx "&					--\
"jng ds8_@x1_ng_x2 "&				-- \
--"xchg ebp,ebx "&				--  should do this outside the loop, but it's easier this way..
"mov eax,ebp mov ebp,ebx mov ebx,eax "&		-- /
"ds8_@x1_ng_x2: "&				--/
"cmp ebp,[maxW] "&
"jg ds8_@yloop_next "&
"cmp ebx,0 "&
"jl ds8_@yloop_next "&
"cmp ebp,0 "&
"jge ds8_@x1_nl_zero "&
"mov ebp,0 "&
"ds8_@x1_nl_zero: "&
"cmp ebx,[maxW] "&
"jng ds8_@x2_ng_maxW "&
"mov ebx,[maxW] "&
"ds8_@x2_ng_maxW: "&
"mov ecx,ebx "&
"sub ecx,ebp "&
"inc ecx "&
"add edi,ebp "&					-- edi += x1
"mov ebp,ecx "&
"and ebp,3 "&
"shr ecx,2 "&
"mov eax,[tri_color] "&
"rep stosd "&
"cmp ebp,0 je ds8_@yloop_next "&
"mov ecx,ebp "&
"rep stosb "&
"ds8_@yloop_next: "&
"mov ebp,[x1] "&
--"mov ebx,[x2] "&
"mov ebx,edx "&
"pop ecx "&
"pop edi "&
"add edi,[screenW] "&
"add ebp,[dxdy_1] "&
"add ebx,[dxdy_2] "&
"dec ecx "&
"jnz ds8_@yloop "&
"mov [x2],ebx "&
"ret")
resolve_param("dxdy_1",tri_data+56)
resolve_param("dxdy_2",tri_data+60)
resolve_param("tri_color",tri_data+68)
resolve_param("start_y",tri_data+96)
resolve_param("end_y",tri_data+100)
resolve_param("x1",tri_data+104)
resolve_param("x2",tri_data+108)
resolve_param("maxH",tMaxH)
resolve_param("maxW",tMaxW)
resolve_param("screenW",tScreenW)



constant tri=get_asm(
" pusha cld "&
" mov esi,[vertex_ptr_1] "&
" mov edi,[vertex_ptr_2] "&
" mov ebx,[vertex_ptr_3] "&
" mov eax,[esi + 4] "&		--eax = y1
" cmp eax,[edi + 4] "&		--cmp y1,y2
"jng tri_@y1_ng_y2 "&
--"  xchg esi,edi "&
" mov eax,esi mov esi,edi mov edi,eax "&
" tri_@y1_ng_y2: "&
" mov eax,[esi + 4] "&		--eax = y1
" cmp eax,[ebx + 4] "&		--cmp y1,y3
"jng tri_@y2_ng_y3 "&
--"  xchg esi,ebx "&
" mov eax,esi mov esi,ebx mov ebx,eax "&
" tri_@y2_ng_y3: "&
" mov eax,[edi + 4] "&		--eax = y2
" cmp eax,[ebx + 4] "&		--cmp y2,y3
"jng tri_@y1_ng_y3 "&
--"  xchg edi,ebx "&
" mov eax,edi mov edi,ebx mov ebx,eax "&
" tri_@y1_ng_y3: "&
" mov [vertex_ptr_1],esi "&
" mov [vertex_ptr_2],edi "&
" mov [vertex_ptr_3],ebx "&
" mov eax,[edi] "&
" sub eax,[esi] "&
" mov [delta_x_1],eax "&
" mov eax,[ebx] "&
" sub eax,[edi] "&
" mov [delta_x_2],eax "&
" mov eax,[ebx] "&		
" sub eax,[esi] "&		
" mov [delta_x_3],eax "&
" mov eax,[edi + 4] "&
" sub eax,[esi + 4] "&
" mov [delta_y_1],eax "&
" mov eax,[ebx + 4] "&
" sub eax,[edi + 4] "&
" mov [delta_y_2],eax "&
" mov eax,[ebx + 4] "&		
" sub eax,[esi + 4] "&		
" mov [delta_y_3],eax "&
" mov ebp,0 "&
" mov [d_1],ebp "&
" mov [d_2],ebp "&
" mov [d_3],ebp "&
" cmp [delta_y_3],0 "&
" jne tri_@keep_going "&
"  popa ret "&			--return if (y3-y1) = 0
" tri_@keep_going: "&
"  inc ebp "&
"  mov eax,[delta_x_3] "&
"  sal eax,8 "&
"  mov ebx,[delta_y_3] "&
"  cwd "&
"  idiv ebx "&
"  mov [d_3],eax "&
" cmp [delta_y_2],0 "&
" je tri_@delta_y_2_zero "&
"  inc ebp "&
"  mov eax,[delta_x_2] "&
"  sal eax,8 "&
"  mov ebx,[delta_y_2] "&
"  cwd "&
"  idiv ebx "&
"  mov [d_2],eax "&
" tri_@delta_y_2_zero: "&
" cmp [delta_y_1],0 "&
" je tri_@delta_y_1_zero "&
"  inc ebp "&
"  mov eax,[delta_x_1] "&
"  sal eax,8 "&
"  mov ebx,[delta_y_1] "&
"  cwd "&
"  idiv ebx "&
"  mov [d_1],eax "&
" tri_@delta_y_1_zero: "&
" cmp ebp,0 "&
" jne tri_@enough_height "&
"  popa ret "&				--return if the triangle has zero height
" tri_@enough_height: "&
" mov eax,[vertex_ptr_1] "&
" mov ebx,[vertex_ptr_2] "&
" mov edx,[eax + 4] "&
" mov eax,[ebx + 4] "&
" mov [start_y],edx "&
" mov [end_y],eax "&
" mov ebx,[vertex_ptr_1] "&
" mov eax,[ebx] "&
" sal eax,9 "&
" mov [x1],eax "&
" mov [x2],eax "&
" mov eax,[d_1] "&
" mov ebx,[d_3] "&
" mov [dxdy_1],eax "&
" mov [dxdy_2],ebx "&
" mov edi,[tri_dest] "&
" mov ebx,[draw_section] "&
" call near ebx "&			--draw upper section
" mov ebx,[vertex_ptr_2] "&
" mov ebx,[ebx] "&
" sal ebx,9 "&
" mov [x1],ebx "&
" mov eax,[vertex_ptr_2] "&
" mov ebx,[vertex_ptr_3] "&
" mov edx,[eax+4] "&
" mov eax,[ebx+4] "&
" mov [start_y],edx "&
" mov [end_y],eax "&
" mov eax,[d_2] "&
" mov ebx,[d_3] "&
" mov [dxdy_1],eax "&
" mov [dxdy_2],ebx "&
" mov edi,[tri_dest] "&
" mov ebx,[draw_section] "&
" call near ebx "&			--draw lower section
" popa ret")
resolve_param("vertex_ptr_1",tri_data)
resolve_param("vertex_ptr_2",tri_data+4)
resolve_param("vertex_ptr_3",tri_data+8)
resolve_param("delta_x_1",tri_data+12)
resolve_param("delta_x_2",tri_data+16)
resolve_param("delta_x_3",tri_data+20)
resolve_param("delta_y_1",tri_data+24)
resolve_param("delta_y_2",tri_data+28)
resolve_param("delta_y_3",tri_data+32)
resolve_param("d_1",tri_data+36)
resolve_param("d_2",tri_data+40)
resolve_param("d_3",tri_data+44)
resolve_param("dxdy_1",tri_data+56)
resolve_param("dxdy_2",tri_data+60)
resolve_param("tri_dest",tri_data+64)
resolve_param("draw_section",hzline_proc)
resolve_param("start_y",tri_data+96)
resolve_param("end_y",tri_data+100)
resolve_param("x1",tri_data+104)
resolve_param("x2",tri_data+108)


poke4(hzline_proc,drawsection8)
poke4(tMaxH,199)
poke4(tMaxW,319)
poke4(tScreenW,320)


global procedure fast_tri(sequence coords,integer color,atom dest)
 poke(tri_data+68,{color,color,color,color})
 poke4(tri_data+64,dest)
 poke4(tri_data+72,coords[1])
 poke4(tri_data,tri_data+72)
 poke4(tri_data+80,coords[2])
 poke4(tri_data+4,tri_data+80)
 poke4(tri_data+88,coords[3])
 poke4(tri_data+8,tri_data+88)
 call(tri)
end procedure
